3 # Copyright (c) 2005, Linus Torvalds
4 # Copyright (c) 2005, Junio C Hamano
6 # Clone a repository into a different directory that does not yet exist.
8 # See git-sh-setup why.
12 echo >&2 "Usage: $0 [--use-separate-remote] [--reference <reference-repo>] [--bare] [-l [-s]] [-q] [-u <upload-pack>] [-o <name>] [-n] <repo> [<dir>]"
17 (cd "$1" && (cd .git ; pwd)) 2> /dev/null
20 if [ -n "$GIT_SSL_NO_VERIFY" ]; then
25 # $1 = Remote, $2 = Local
26 curl -nsfL $curl_extra_args "$1" >"$2"
30 # $1 - remote, $2 - local
32 clone_tmp='.git/clone-tmp' &&
33 mkdir -p "$clone_tmp" || exit 1
34 http_fetch "$1/info/refs" "$clone_tmp/refs" || {
35 echo >&2 "Cannot get remote repository information.
36 Perhaps git-update-server-info needs to be run there?"
39 while read sha1 refname
41 name=`expr "$refname" : 'refs/\(.*\)'` &&
45 if test -n "$use_separate_remote" &&
46 branch_name=`expr "$name" : 'heads/\(.*\)'`
48 tname="remotes/$origin/$branch_name"
52 git-http-fetch -v -a -w "$tname" "$name" "$1/" || exit 1
53 done <"$clone_tmp/refs"
55 http_fetch "$1/HEAD" "$GIT_DIR/REMOTE_HEAD"
58 # Read git-fetch-pack -k output and store the remote branches.
60 use File::Path qw(mkpath);
61 use File::Basename qw(dirname);
62 my $git_dir = $ARGV[0];
63 my $use_separate_remote = $ARGV[1];
64 my $origin = $ARGV[2];
66 my $branch_top = ($use_separate_remote ? "remotes/$origin" : "heads");
70 my ($sha1, $name, $top) = @_;
71 $name = "$git_dir/refs/$top/$name";
72 mkpath(dirname($name));
78 open FH, "<", "$git_dir/CLONE_HEAD";
80 my ($sha1, $name) = /^([0-9a-f]{40})\s(.*)$/;
81 next if ($name =~ /\^\173/);
82 if ($name eq "HEAD") {
83 open O, ">", "$git_dir/REMOTE_HEAD";
88 if ($name =~ s/^refs\/heads\///) {
89 store($sha1, $name, $branch_top);
92 if ($name =~ s/^refs\/tags\///) {
93 store($sha1, $name, $tag_top);
113 *,-n|*,--no|*,--no-|*,--no-c|*,--no-ch|*,--no-che|*,--no-chec|\
114 *,--no-check|*,--no-checko|*,--no-checkou|*,--no-checkout)
116 *,--na|*,--nak|*,--nake|*,--naked|\
117 *,-b|*,--b|*,--ba|*,--bar|*,--bare) bare=yes ;;
118 *,-l|*,--l|*,--lo|*,--loc|*,--loca|*,--local) use_local=yes ;;
119 *,-s|*,--s|*,--sh|*,--sha|*,--shar|*,--share|*,--shared)
120 local_shared=yes; use_local=yes ;;
121 *,-q|*,--quiet) quiet=-q ;;
122 *,--use-separate-remote)
123 use_separate_remote=t ;;
125 1,--reference) usage ;;
127 shift; reference="$1" ;;
129 reference=`expr "$1" : '--reference=\(.*\)'` ;;
133 echo >&2 "'$2' is not suitable for an origin name"
136 git-check-ref-format "heads/$2" || {
137 echo >&2 "'$2' is not suitable for a branch name"
140 test -z "$origin_override" || {
141 echo >&2 "Do not give more than one -o options."
147 1,-u|1,--upload-pack) usage ;;
148 *,-u|*,--upload-pack)
150 upload_pack="--exec=$1" ;;
158 # --bare implies --no-checkout
159 if test yes = "$bare"
161 if test yes = "$origin_override"
163 echo >&2 '--bare and -o $origin options are incompatible.'
166 if test t = "$use_separate_remote"
168 echo >&2 '--bare and --use-separate-remote options are incompatible.'
179 # Turn the source into an absolute path if
183 if base=$(get_repo_base "$repo"); then
189 # Try using "humanish" part of source repo if user didn't specify one
190 [ -z "$dir" ] && dir=$(echo "$repo" | sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
191 [ -e "$dir" ] && echo "$dir already exists." && usage
193 D=$(cd "$dir" && pwd) &&
194 trap 'err=$?; cd ..; rm -r "$D"; exit $err' exit
197 *) GIT_DIR="$D/.git" ;;
198 esac && export GIT_DIR && git-init-db || usage
206 if test -n "$reference"
208 if test -d "$reference"
210 if test -d "$reference/.git/objects"
212 reference="$reference/.git"
214 reference=$(cd "$reference" && pwd)
215 echo "$reference/objects" >"$GIT_DIR/objects/info/alternates"
216 (cd "$reference" && tar cf - refs) |
217 (cd "$GIT_DIR/refs" &&
218 mkdir reference-tmp &&
222 echo >&2 "$reference: not a local directory." && usage
226 rm -f "$GIT_DIR/CLONE_HEAD"
228 # We do local magic only when the user tells us to.
229 case "$local,$use_local" in
231 ( cd "$repo/objects" ) || {
232 echo >&2 "-l flag seen but $repo is not local."
236 case "$local_shared" in
238 # See if we can hardlink and drop "l" if not.
239 sample_file=$(cd "$repo" && \
240 find objects -type f -print | sed -e 1q)
242 # objects directory should not be empty since we are cloning!
243 test -f "$repo/$sample_file" || exit
246 if ln "$repo/$sample_file" "$GIT_DIR/objects/sample" 2>/dev/null
250 rm -f "$GIT_DIR/objects/sample" &&
252 find objects -depth -print | cpio -pumd$l "$GIT_DIR/" || exit 1
255 mkdir -p "$GIT_DIR/objects/info"
257 test -f "$repo/objects/info/alternates" &&
258 cat "$repo/objects/info/alternates";
260 } >"$GIT_DIR/objects/info/alternates"
263 git-ls-remote "$repo" >"$GIT_DIR/CLONE_HEAD"
268 rsync $quiet -av --ignore-existing \
269 --exclude info "$repo/objects/" "$GIT_DIR/objects/" ||
271 # Look at objects/info/alternates for rsync -- http will
272 # support it natively and git native ones will do it on the
273 # remote end. Not having that file is not a crime.
274 rsync -q "$repo/objects/info/alternates" \
275 "$GIT_DIR/TMP_ALT" 2>/dev/null ||
276 rm -f "$GIT_DIR/TMP_ALT"
277 if test -f "$GIT_DIR/TMP_ALT"
280 . git-parse-remote &&
281 resolve_alternates "$repo" <"$GIT_DIR/TMP_ALT" ) |
284 case "$alt" in 'bad alternate: '*) die "$alt";; esac
286 '') echo >&2 "Getting alternate: $alt" ;;
288 rsync $quiet -av --ignore-existing \
289 --exclude info "$alt" "$GIT_DIR/objects" || exit
291 rm -f "$GIT_DIR/TMP_ALT"
293 git-ls-remote "$repo" >"$GIT_DIR/CLONE_HEAD"
296 if test -z "@@NO_CURL@@"
298 clone_dumb_http "$repo" "$D"
300 echo >&2 "http transport not supported, rebuild Git with curl support"
305 cd "$D" && case "$upload_pack" in
306 '') git-fetch-pack --all -k $quiet "$repo" ;;
307 *) git-fetch-pack --all -k $quiet "$upload_pack" "$repo" ;;
308 esac >"$GIT_DIR/CLONE_HEAD" || {
309 echo >&2 "fetch-pack from '$repo' failed."
316 test -d "$GIT_DIR/refs/reference-tmp" && rm -fr "$GIT_DIR/refs/reference-tmp"
318 if test -f "$GIT_DIR/CLONE_HEAD"
320 # Figure out where the remote HEAD points at.
321 perl -e "$copy_refs" "$GIT_DIR" "$use_separate_remote" "$origin"
326 if test -z "$bare" && test -f "$GIT_DIR/REMOTE_HEAD"
328 head_sha1=`cat "$GIT_DIR/REMOTE_HEAD"`
329 # Figure out which remote branch HEAD points at.
330 case "$use_separate_remote" in
331 '') remote_top=refs/heads ;;
332 *) remote_top="refs/remotes/$origin" ;;
335 # What to use to track the remote primary branch
336 if test -n "$use_separate_remote"
338 origin_tracking="remotes/$origin/master"
340 origin_tracking="heads/$origin"
343 # The name under $remote_top the remote HEAD seems to point at
347 cd "$GIT_DIR/$remote_top" &&
348 find . -type f -print | sed -e 's/^\.\///'
353 test t = $done && continue
354 branch_tip=`cat "$GIT_DIR/$remote_top/$name"`
355 if test "$head_sha1" = "$branch_tip"
364 # Write out remotes/$origin file.
365 case "$head_points_at" in
367 mkdir -p "$GIT_DIR/remotes" &&
368 echo >"$GIT_DIR/remotes/$origin" \
370 Pull: refs/heads/$head_points_at:refs/$origin_tracking" &&
371 case "$use_separate_remote" in
372 t) git-update-ref HEAD "$head_sha1" ;;
373 *) git-update-ref "refs/heads/$origin" $(git-rev-parse HEAD) ;;
375 (cd "$GIT_DIR/$remote_top" && find . -type f -print) |
378 name=`expr "$dotslref" : './\(.*\)'` &&
379 test "$head_points_at" = "$name" ||
380 test "$origin" = "$name" ||
381 echo "Pull: refs/heads/${name}:$remote_top/${name}"
382 done >>"$GIT_DIR/remotes/$origin" &&
383 case "$use_separate_remote" in
385 rm -f "refs/remotes/$origin/HEAD"
386 git-symbolic-ref "refs/remotes/$origin/HEAD" \
387 "refs/remotes/$origin/$head_points_at"
391 case "$no_checkout" in
393 git-read-tree -m -u -v HEAD HEAD
396 rm -f "$GIT_DIR/CLONE_HEAD" "$GIT_DIR/REMOTE_HEAD"